import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class PinBallGame extends Frame
{
   private static final int FrameWidth  = 400;
   private static final int FrameHeight = 400;
   private Vector balls;

   public PinBallGame()
   {
      setTitle( "Pin Ball Construction Kit" );
      setSize ( FrameWidth, FrameHeight );

      balls = new Vector();

      addMouseListener( new MouseKeeper() );
   }

   public void paint( Graphics g )
   {
      g.setColor( Color.white );
      g.fillRect( FrameWidth-40, FrameHeight-40, 30, 30 );
      g.setColor( Color.red );
      g.fillOval( FrameWidth-40, FrameHeight-40, 30, 30 );

      for (int i = 0; i < balls.size(); i++)
      {
         PinBall aBall = (PinBall) balls.elementAt( i );
	   aBall.paint( g );
      }
   }

   private class MouseKeeper extends MouseAdapter
   {
      public void mousePressed( MouseEvent e )
      {
         int x = e.getX();
	   int y = e.getY();
	   if ( (x > FrameWidth-40) && (y > FrameHeight -40) )
         {
	      PinBall newBall = new PinBall( e.getX(), e.getY() );
	      balls.addElement( newBall );
	      Thread newThread = new PinBallThread(
                                        newBall, PinBallGame.this );
	      newThread.start();
	   }
      }
   }
}

